require "omniauth"
require "omniauth/whichsignupapi/api_methods"
require "omniauth/whichsignupapi/auth_hash_delegate"
require "omniauth/whichsignupapi/auth_hash_delegator"

module OmniAuth
  module Strategies
    class Whichsignupapi
      include OmniAuth::Strategy
      include OmniAuth::Whichsignupapi::AuthHashDelegator

      option :name, 'whichsignupapi'
      option :api_url 
      option :api_secret
      option :token_secret

      def request_phase
        form = OmniAuth::Form.new(:title => "Which? Login", :url => callback_path)
        form.text_field "Email or Which? username", 'login'
        form.text_field "Password", 'password'
        form.button "Sign In"
        form.to_response
      end

      def callback_phase
        results = authenticate(request['login'], request['password'])
        delegate_to(results)
        super
      end

      def handles(login)
        OmniAuth::Whichsignupapi::ApiMethods.handles(options['api_url'], options['api_secret'], options['token_secret'], login)
      end

      def authenticate(login, password, always_get_details = false)
        result = OmniAuth::Whichsignupapi::ApiMethods.login(options['api_url'], options['api_secret'], options['token_secret'], login, password || '', always_get_details)
        fail!(:invalid_credentials) unless result[:authenticated] || always_get_details
        OmniAuth::Whichsignupapi::AuthHashDelegate.new(options['name'], result)
      end
    end
  end
end