module OmniAuth
  module Whichsignupapi
    class AuthHashDelegate
      def initialize(provider_name, user_info)
        @user_info = user_info
        @provider_name = provider_name
      end

      def provider
        @provider_name
      end

      def raw
        @user_info
      end

      def uid
        @user_info[:customer_id]
      end

      def info
        {
          name: @user_info[:screen_name] || @user_info[:user_name],
          nickname: @user_info[:screen_name]
        }
      end

      def extra
        {
          as: @user_info[:as],
          user_name: @user_info[:user_name],
          raw_info: @user_info
        }
      end
    end
  end
end